## libpg-query 13-2.1.0

=== debian/changelog ===
libpg-query (13-2.1.0-2) unstable; urgency=medium

  * Include server include files for missing atomics-{ia64,hppa}.h.
  * Run less threads in parallel in tests.
  * Set team as Maintainer.

 -- Christoph Berg <myon@debian.org>  Thu, 10 Feb 2022 12:23:26 +0100

libpg-query (13-2.1.0-1) unstable; urgency=medium

  * Initial release.

 -- Christoph Berg <myon@debian.org>  Thu, 03 Feb 2022 12:50:09 +0100
