=== debian/control ===
Source: libpg-query
Priority: optional
Maintainer: Debian PostgreSQL Maintainers <team+postgresql@tracker.debian.org>
Uploaders:
 Christoph Berg <myon@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 postgresql-server-dev-all,
 protobuf-c-compiler,
Standards-Version: 4.6.0
Section: libs
Homepage: https://github.com/pganalyze/libpg_query
Vcs-Browser: https://salsa.debian.org/postgresql/libpg-query
Vcs-Git: https://salsa.debian.org/postgresql/libpg-query.git
Rules-Requires-Root: no

Package: libpg-query-dev
Section: libdevel
Architecture: any
Depends: libpg-query1302.1 (= ${binary:Version}), ${misc:Depends}
Description: C library for accessing the PostgreSQL parser outside of the server environment
 This library uses the actual PostgreSQL server source to parse SQL queries and
 return the internal PostgreSQL parse tree.

Package: libpg-query1302.1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C library for accessing the PostgreSQL parser outside of the server environment
 This library uses the actual PostgreSQL server source to parse SQL queries and
 return the internal PostgreSQL parse tree.
