=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

override_dh_auto_build:
	$(MAKE) build VERBOSE=1

override_dh_auto_test:
	$(MAKE) examples test TEST_CFLAGS='$$(CPPFLAGS) $$(CFLAGS)' TEST_LDFLAGS='$$(LDFLAGS)'

%:
	dh $@
