=== debian/watch ===
version=4
https://github.com/pganalyze/libpg_query/tags .*/(.*).tar.gz
