## libpg-query 13-2.1.1

=== debian/changelog ===
libpg-query (13-2.1.1-1.pgdg90+1) stretch-pgdg; urgency=medium

  * Rebuild for stretch-pgdg.
  * Changes applied by generate-pgdg-source:
    + Using debhelper 10.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Mon, 09 May 2022 12:51:24 +0200

libpg-query (13-2.1.1-1) unstable; urgency=medium

  * New upstream version.
  * Install examples/*.c.

 -- Christoph Berg <myon@debian.org>  Mon, 09 May 2022 12:51:24 +0200
