=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Uploaders:
  Christoph Berg <myon@debian.org>,
 Build-Depends:
- debhelper-compat (= 13),
+ debhelper (>= 10),
  postgresql-server-dev-all,
  protobuf-c-compiler,
 Standards-Version: 4.6.0
