## libpg-query 15

=== Makefile ===
--- 
+++ 
@@ -3,21 +3,31 @@
 
 TARGET = pg_query
 ARLIB = lib$(TARGET).a
-SOLIB = lib$(TARGET).so
 PGDIR = $(root_dir)/tmp/postgres
 PGDIRBZ2 = $(root_dir)/tmp/postgres.tar.bz2
 
-PG_VERSION = 13.3
+PG_VERSION = 15.1
 PG_VERSION_MAJOR = $(call word-dot,$(PG_VERSION),1)
 PROTOC_VERSION = 3.14.0
 
-VERSION = 2.1.1
+VERSION = 4.2.3
 VERSION_MAJOR = $(call word-dot,$(VERSION),1)
 VERSION_MINOR = $(call word-dot,$(VERSION),2)
 VERSION_PATCH = $(call word-dot,$(VERSION),3)
 
-SONAME = $(SOLIB).$(shell printf '%02d%02d' $(PG_VERSION_MAJOR) $(VERSION_MAJOR)).$(VERSION_MINOR)
-SOLIBVER = $(SONAME).$(VERSION_PATCH)
+SO_VERSION = $(shell printf '%02d%02d' $(PG_VERSION_MAJOR) $(VERSION_MAJOR)).$(VERSION_MINOR)
+
+ifeq ($(shell uname -s), Darwin)
+	SOLIB = lib$(TARGET).dylib
+	SONAME = lib$(TARGET).$(SO_VERSION).dylib
+	SOLIBVER = lib$(TARGET).$(SO_VERSION).$(VERSION_PATCH).dylib
+	SOFLAG = -install_name
+else
+	SOLIB = lib$(TARGET).so
+	SONAME = $(SOLIB).$(SO_VERSION)
+	SOLIBVER = $(SONAME).$(VERSION_PATCH)
+	SOFLAG = -soname
+endif
 
 SRC_FILES := $(wildcard src/*.c src/postgres/*.c) vendor/protobuf-c/protobuf-c.c vendor/xxhash/xxhash.c protobuf/pg_query.pb-c.c
 NOT_OBJ_FILES := src/pg_query_enum_defs.o src/pg_query_fingerprint_defs.o src/pg_query_fingerprint_conds.o src/pg_query_outfuncs_defs.o src/pg_query_outfuncs_conds.o src/pg_query_readfuncs_defs.o src/pg_query_readfuncs_conds.o src/postgres/guc-file.o src/postgres/scan.o src/pg_query_json_helper.o
@@ -103,19 +113,45 @@
 	tar -xjf $(PGDIRBZ2)
 	mv $(root_dir)/postgresql-$(PG_VERSION) $(PGDIR)
 	cd $(PGDIR); patch -p1 < $(root_dir)/patches/01_parser_additional_param_ref_support.patch
-	cd $(PGDIR); patch -p1 < $(root_dir)/patches/02_parser_support_question_mark_as_param_ref.patch
 	cd $(PGDIR); patch -p1 < $(root_dir)/patches/03_lexer_track_yyllocend.patch
 	cd $(PGDIR); patch -p1 < $(root_dir)/patches/04_lexer_comments_as_tokens.patch
 	cd $(PGDIR); patch -p1 < $(root_dir)/patches/05_limit_option_enum_value_default.patch
 	cd $(PGDIR); patch -p1 < $(root_dir)/patches/06_alloc_set_delete_free_list.patch
 	cd $(PGDIR); patch -p1 < $(root_dir)/patches/07_plpgsql_start_finish_datums.patch
 	cd $(PGDIR); patch -p1 < $(root_dir)/patches/08_avoid_zero_length_delimiter_in_regression_tests.patch
+	cd $(PGDIR); patch -p1 < $(root_dir)/patches/09_allow_trailing_junk.patch
 	cd $(PGDIR); ./configure $(PG_CONFIGURE_FLAGS)
 	cd $(PGDIR); rm src/pl/plpgsql/src/pl_gram.h
 	cd $(PGDIR); make -C src/pl/plpgsql/src pl_gram.h
 	cd $(PGDIR); make -C src/port pg_config_paths.h
 	cd $(PGDIR); make -C src/backend generated-headers
 	cd $(PGDIR); make -C src/backend parser-recursive # Triggers copying of includes to where they belong, as well as generating gram.c/scan.c
+	# This causes compatibility problems on some Linux distros, with "xlocale.h" not being available
+	echo "#undef HAVE_LOCALE_T" >> $(PGDIR)/src/include/pg_config.h
+	echo "#undef LOCALE_T_IN_XLOCALE" >> $(PGDIR)/src/include/pg_config.h
+	echo "#undef WCSTOMBS_L_IN_XLOCALE" >> $(PGDIR)/src/include/pg_config.h
+	# Support 32-bit systems without reconfiguring
+	echo "#undef PG_INT128_TYPE" >> $(PGDIR)/src/include/pg_config.h
+	# Support gcc earlier than 4.6.0 without reconfiguring
+	echo "#undef HAVE__STATIC_ASSERT" >> $(PGDIR)/src/include/pg_config.h
+	# Avoid problems with static asserts
+	echo "#undef StaticAssertDecl" >> $(PGDIR)/src/include/c.h
+	echo "#define StaticAssertDecl(condition, errmessage)" >> $(PGDIR)/src/include/c.h
+	# Avoid dependency on execinfo (requires extra library on musl-libc based systems)
+	echo "#undef HAVE_EXECINFO_H" >> $(PGDIR)/src/include/pg_config.h
+	echo "#undef HAVE_BACKTRACE_SYMBOLS" >> $(PGDIR)/src/include/pg_config.h
+	# Avoid dependency on hardware popcount instructions (POPQNTQ) on x86
+	echo "#undef HAVE_X86_64_POPCNTQ" >> $(PGDIR)/src/include/pg_config.h
+	# Avoid dependency on cpuid.h (only supported on x86 systems)
+	echo "#undef HAVE__GET_CPUID" >> $(PGDIR)/src/include/pg_config.h
+	# Avoid CRC extension usage to ensure we are not architecture-dependent
+	echo "#undef USE_ARMV8_CRC32C" >> $(PGDIR)/src/include/pg_config.h
+	echo "#undef USE_SSE42_CRC32C_WITH_RUNTIME_CHECK" >> $(PGDIR)/src/include/pg_config.h
+	# Ensure we don't fail on systems that have strchrnul support (FreeBSD and NetBSD)
+	echo "#include <stdlib.h>" >>  $(PGDIR)/src/include/pg_config.h
+	echo "#if defined(__FreeBSD__) || defined(__NetBSD__) || (defined(__GLIBC__) && ((__GLIBC__ == 2 && __GLIBC_MINOR__ >= 38) || __GLIBC__ > 2))" >> $(PGDIR)/src/include/pg_config.h
+	echo "#define HAVE_STRCHRNUL" >> $(PGDIR)/src/include/pg_config.h
+	echo "#endif" >> $(PGDIR)/src/include/pg_config.h
 
 extract_source: $(PGDIR)
 	-@ $(RM) -rf ./src/postgres/
@@ -123,29 +159,10 @@
 	mkdir ./src/postgres/include
 	LIBCLANG=/Library/Developer/CommandLineTools/usr/lib/libclang.dylib ruby ./scripts/extract_source.rb $(PGDIR)/ ./src/postgres/
 	cp $(PGDIR)/src/include/storage/dsm_impl.h ./src/postgres/include/storage
+	cp $(PGDIR)/src/include/port/atomics/arch-x86.h ./src/postgres/include/port/atomics
 	cp $(PGDIR)/src/include/port/atomics/arch-arm.h ./src/postgres/include/port/atomics
 	cp $(PGDIR)/src/include/port/atomics/arch-ppc.h ./src/postgres/include/port/atomics
 	touch ./src/postgres/guc-file.c
-	# This causes compatibility problems on some Linux distros, with "xlocale.h" not being available
-	echo "#undef HAVE_LOCALE_T" >> ./src/postgres/include/pg_config.h
-	echo "#undef LOCALE_T_IN_XLOCALE" >> ./src/postgres/include/pg_config.h
-	echo "#undef WCSTOMBS_L_IN_XLOCALE" >> ./src/postgres/include/pg_config.h
-	# Support 32-bit systems without reconfiguring
-	echo "#undef PG_INT128_TYPE" >> ./src/postgres/include/pg_config.h
-	# Support gcc earlier than 4.6.0 without reconfiguring
-	echo "#undef HAVE__STATIC_ASSERT" >> ./src/postgres/include/pg_config.h
-	# Avoid problems with static asserts
-	echo "#undef StaticAssertDecl" >> ./src/postgres/include/c.h
-	echo "#define StaticAssertDecl(condition, errmessage)" >> ./src/postgres/include/c.h
-	# Avoid dependency on execinfo (requires extra library on musl-libc based systems)
-	echo "#undef HAVE_EXECINFO_H" >> ./src/postgres/include/pg_config.h
-	echo "#undef HAVE_BACKTRACE_SYMBOLS" >> ./src/postgres/include/pg_config.h
-	# Avoid dependency on cpuid.h (only supported on x86 systems)
-	echo "#undef HAVE__GET_CPUID" >> ./src/postgres/include/pg_config.h
-	# Ensure we don't fail on systems that have strchrnul support (FreeBSD)
-	echo "#ifdef __FreeBSD__" >> ./src/postgres/include/pg_config.h
-	echo "#define HAVE_STRCHRNUL" >> ./src/postgres/include/pg_config.h
-	echo "#endif" >> ./src/postgres/include/pg_config.h
 	# Copy version information so its easily accessible
 	sed -i "" '$(shell echo 's/\#define PG_MAJORVERSION .*/'`grep "\#define PG_MAJORVERSION " ./src/postgres/include/pg_config.h`'/')' pg_query.h
 	sed -i "" '$(shell echo 's/\#define PG_VERSION .*/'`grep "\#define PG_VERSION " ./src/postgres/include/pg_config.h`'/')' pg_query.h
@@ -166,7 +183,7 @@
 	@$(AR) $@ $(OBJ_FILES)
 
 $(SOLIB): $(OBJ_FILES) Makefile
-	@$(CC) $(CFLAGS) -shared -Wl,-soname,$(SONAME) $(LDFLAGS) -o $@ $(OBJ_FILES) $(LIBS)
+	@$(CC) $(CFLAGS) -shared -Wl,$(SOFLAG),$(SONAME) $(LDFLAGS) -o $@ $(OBJ_FILES) $(LIBS)
 
 protobuf/pg_query.pb-c.c protobuf/pg_query.pb-c.h: protobuf/pg_query.proto
 ifneq ($(shell which protoc-gen-c), )
@@ -250,21 +267,3 @@
 	$(CC) $(TEST_CFLAGS) -o $@ test/concurrency.c $(ARLIB) $(TEST_LDFLAGS)
 
 test/deparse: test/deparse.c test/deparse_tests.c $(ARLIB)
-	$(CC) $(TEST_CFLAGS) -o $@ test/deparse.c $(ARLIB) $(TEST_LDFLAGS)
-
-test/fingerprint: test/fingerprint.c test/fingerprint_tests.c $(ARLIB)
-	# We have "-Isrc/" because this test uses pg_query_fingerprint_with_opts
-	$(CC) $(TEST_CFLAGS) -o $@ -Isrc/ test/fingerprint.c $(ARLIB) $(TEST_LDFLAGS)
-
-test/normalize: test/normalize.c test/normalize_tests.c $(ARLIB)
-	$(CC) $(TEST_CFLAGS) -o $@ test/normalize.c $(ARLIB) $(TEST_LDFLAGS)
-
-test/parse: test/parse.c test/parse_tests.c $(ARLIB)
-	$(CC) $(TEST_CFLAGS) -o $@ test/parse.c $(ARLIB) $(TEST_LDFLAGS)
-
-test/parse_plpgsql: test/parse_plpgsql.c test/parse_tests.c $(ARLIB)
-	$(CC) $(TEST_CFLAGS) -o $@ test/parse_plpgsql.c $(ARLIB) $(TEST_LDFLAGS)
-
-test/parse_protobuf: test/parse_protobuf.c test/parse_tests.c $(ARLIB)
-	$(CC) $(TEST_CFLAGS) -o $@ test/parse_protobuf.c $(ARLIB) $(TEST_LDFLAGS)
-
