## libpg-query 15-4.0.0

=== debian/changelog ===
libpg-query (15-4.0.0-2.pgdg20.04+1) focal-pgdg; urgency=medium

  * Rebuild for focal-pgdg.
  * Changes applied by generate-pgdg-source:
    + Using debhelper 12.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Mon, 02 Jan 2023 20:24:14 +0200

libpg-query (15-4.0.0-2) unstable; urgency=medium

  * Fix size of PgQueryProtobuf.len.

 -- Christoph Berg <myon@debian.org>  Mon, 02 Jan 2023 20:24:14 +0200

libpg-query (15-4.0.0-1) unstable; urgency=medium

  * New upstream version with new soname.
  * Ignore test failures on 32-bit architectures.

 -- Christoph Berg <myon@debian.org>  Fri, 16 Dec 2022 13:34:55 +0100

libpg-query (13-2.1.2-2) unstable; urgency=medium

  * src/postgres/include/storage/s_lock.h: Import RISC-V tas definition.
    (Closes: #1014082, thanks Bo YU)

 -- Christoph Berg <myon@debian.org>  Tue, 05 Jul 2022 15:30:22 +0200
