=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Uploaders:
  Christoph Berg <myon@debian.org>,
 Build-Depends:
- debhelper (>= 11),
+ debhelper (>= 12),
  postgresql-server-dev-all,
  protobuf-c-compiler,
 Standards-Version: 4.6.0
@@ -17,12 +17,13 @@
 Package: libpg-query-dev
 Section: libdevel
 Architecture: any
-Depends: libpg-query1302.1 (= ${binary:Version}), ${misc:Depends}
+Depends: libpg-query1504.0 (= ${binary:Version}), ${misc:Depends}
+Multi-Arch: same
 Description: C library for accessing the PostgreSQL parser outside of the server environment
  This library uses the actual PostgreSQL server source to parse SQL queries and
  return the internal PostgreSQL parse tree.
 
-Package: libpg-query1302.1
+Package: libpg-query1504.0
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
