## libpg-query 15-4.2.0

=== debian/changelog ===
libpg-query (15-4.2.0-1.pgdg23.04+1) lunar-pgdg; urgency=medium

  * Rebuild for lunar-pgdg.
  * No source changes.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Tue, 07 Feb 2023 09:40:43 +0100

libpg-query (15-4.2.0-1) unstable; urgency=medium

  * New upstream version.
  * Pin SONAME to 1504.1 since nothing changed.

 -- Christoph Berg <myon@debian.org>  Tue, 07 Feb 2023 09:40:43 +0100

libpg-query (15-4.1.0-1) unstable; urgency=medium

  * New upstream version with new soname.

 -- Christoph Berg <myon@debian.org>  Fri, 03 Feb 2023 09:58:59 +0100
