## libpg-query 15-4.2.1

=== debian/changelog ===
libpg-query (15-4.2.1-1.pgdg20.04+1) focal-pgdg; urgency=medium

  * Rebuild for focal-pgdg.
  * Changes applied by generate-pgdg-source:
    + Using debhelper 12.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Tue, 20 Jun 2023 15:12:08 +0200

libpg-query (15-4.2.1-1) unstable; urgency=medium

  * New upstream version.

 -- Christoph Berg <myon@debian.org>  Tue, 20 Jun 2023 15:12:08 +0200

libpg-query (15-4.2.0-1) experimental; urgency=medium

  * New upstream version.
  * Pin SONAME to 1504.1 since nothing changed.

 -- Christoph Berg <myon@debian.org>  Tue, 07 Feb 2023 09:40:43 +0100

libpg-query (15-4.1.0-1) experimental; urgency=medium

  * New upstream version with new soname.

 -- Christoph Berg <myon@debian.org>  Fri, 03 Feb 2023 09:58:59 +0100
