## libpg-query 15-4.2.2

=== debian/changelog ===
libpg-query (15-4.2.2-1.pgdg22.10+1) kinetic-pgdg; urgency=medium

  * Rebuild for kinetic-pgdg.
  * No source changes.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Tue, 11 Jul 2023 12:15:28 +0200

libpg-query (15-4.2.2-1) unstable; urgency=medium

  * New upstream version.

 -- Christoph Berg <myon@debian.org>  Tue, 11 Jul 2023 12:15:28 +0200
