## libpg-query 15-4.2.3

=== debian/changelog ===
libpg-query (15-4.2.3-1) unstable; urgency=medium

  * New upstream version.
  * debian/libpg-query1504.1.symbols: Add deparseRawStmt.

 -- Christoph Berg <myon@debian.org>  Tue, 08 Aug 2023 22:20:09 +0200
