## libpg-query 16-5.0.0

=== debian/changelog ===
libpg-query (16-5.0.0-1.pgdg20.04+1) focal-pgdg; urgency=medium

  * Rebuild for focal-pgdg.
  * Changes applied by generate-pgdg-source:
    + Using debhelper 12.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Fri, 05 Jan 2024 14:42:45 +0100

libpg-query (16-5.0.0-1) experimental; urgency=medium

  * New upstream version 16-5.0.0.
  * Bump soname to libpg-query1605.0.
  * Use correct word size on all architectures.

 -- Christoph Berg <myon@debian.org>  Fri, 05 Jan 2024 14:42:45 +0100

libpg-query (15-4.2.3-2) unstable; urgency=medium

  * libpq-query-dev: Install postgresql server headers so pglast doesn't have
    to depend on a specific postgresql-server-dev-NN version.

 -- Christoph Berg <myon@debian.org>  Thu, 23 Nov 2023 12:18:47 +0000
