## libpg-query 16-5.1.0

=== debian/changelog ===
libpg-query (16-5.1.0-2.pgdg20.04+1) focal-pgdg; urgency=medium

  * Rebuild for focal-pgdg.
  * Changes applied by generate-pgdg-source:
    + Using debhelper 12.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Wed, 10 Jan 2024 15:49:27 +0100

libpg-query (16-5.1.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Christoph Berg <myon@debian.org>  Wed, 10 Jan 2024 15:49:27 +0100

libpg-query (16-5.1.0-1) experimental; urgency=medium

  * New upstream version 16-5.1.0.
  * Bump soname to libpg-query1605.1.
  * Re-enable tests on 32-bit.

 -- Christoph Berg <myon@debian.org>  Tue, 09 Jan 2024 15:59:28 +0100
