=== debian/control ===
--- 
+++ 
@@ -17,13 +17,13 @@
 Package: libpg-query-dev
 Section: libdevel
 Architecture: any
-Depends: libpg-query1605.0 (= ${binary:Version}), ${misc:Depends}
+Depends: libpg-query1605.1 (= ${binary:Version}), ${misc:Depends}
 Multi-Arch: same
 Description: C library for accessing the PostgreSQL parser outside of the server environment
  This library uses the actual PostgreSQL server source to parse SQL queries and
  return the internal PostgreSQL parse tree.
 
-Package: libpg-query1605.0
+Package: libpg-query1605.1
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
